!function(win,ui){
    if(!ui.districtPopup){
        var Popup = lib.popup,Event = lib.event,District = widget.district;
        ui.districtPopup = function(_level){
            _level = _level||4;
            return new Popup({
                title:'请选择配送区域',
                content:'<div class="district-selector"><ul></ul></div>',
                closeType:'hide',
                init:function($cover){
                    Event.extend.call(this);
                    var that = this;
                    var superShow = this.show,superHide = this.hide;
                    var level = 0,result = [];
                    function render(Pid){
                        District.fetchAreaSource(Pid,function(data){
                            var html = [];
                            for(var i=0;i<data.length;i++){
                                var districtId = data[i][0],districtName = data[i][1];
                                html.push('<li district-level="'+level+'" district-id="'+districtId+'" district-name="'+districtName+'"><span>'+districtName+'</span><i class="icon-arrow-right"></i></li>');
                            }
                            $cover.find('.popup').scrollTop(0).find('.content').scrollTop(0);
                            $cover.find('.district-selector ul').html(html.join(''));
                            level++;
                            $cover.on('tap','.district-selector ul li',tapFunc);
                        });
                    }
                    function tapFunc(event){
                        $cover.off('tap','.district-selector ul li',tapFunc);
                        var districtId = $(this).attr('district-id');
                        var districtName = $(this).attr('district-name');
                        result.push([districtId,districtName]);
                        if(level>=_level){
                            that.dispatchEvent({
                                type:'district-result',
                                data:result
                            });
                            that.hide();
                        }else{
                            render(districtId);
                        }
                        event.touchEvent.stopPropagation();
                        event.touchEvent.preventDefault();
                    }
                    $cover.on('tap','.district-selector ul li',tapFunc);
                    this.show = function(){
                        superShow();
                    };
                    this.hide = function(){
                        level = 0;
                        result=[];
                        render(0);
                        superHide();
                    };
                    render(0);
                }
            });
        }
    }
}(window,window['ui'] || (window['ui'] = {}));