!function(win,widget){
    function toNumber(value,min,max){
        value = value.toString().replace(/\D/g,'');
        return parseInt(value||0);
    }
    function counter(options){
        var _this = this;
        var _default={
            input:"",
            plus:"",
            minus:"",
            max:999,
            min:1,
            clickEvent:"tap",
            change:null
        };
        options= $.extend({},_default,options);
        var maxNumber=options.max||false,$input=$(options.input),$increase=$(options.plus),$decrease=$(options.minus);
        var $inputText = $('<span class="input-text">'+$input.val()+'</span>');
        $input.attr('type','hidden').before($inputText);
        var changeFunc = options.change;
        function count(num,max_number){
            num=num||0,max_number=typeof(max_number)=="undefined"?false:!max_number?0:max_number;
            var _value;
            if(max_number===0){
                _value=0;
            }else{
                _value=eval([toNumber($input.val()),num].join("+"));
                _value=(max_number===0||max_number==="0")?0:(_value>=max_number&&max_number!==false?max_number:(_value<=options.min?options.min:_value));
            }
            $input.val(_value);
            $inputText.text(_value);
            typeof(changeFunc)=='function'&&changeFunc.call(_this,_value);
            return _value;
        }
        function toNumber(number){
            if(typeof(number)=="string"){
                number=!isNaN(parseInt(number.replace(/\D/g,"")))?parseInt(number.replace(/\D/g,"")):0;
            }else if(typeof(number)!="number"||isNaN(number)){
                number=0;
            }
            return number;
        }
        function disableCheck(){
            var value=toNumber($input.val());
            $increase[value>=maxNumber?"addClass":"removeClass"]("disable_increase");
            $decrease[value<=options.min?"addClass":"removeClass"]("disable_decrease");
        }
        $decrease.on(options.clickEvent,function(){
            count(-1,maxNumber);
            disableCheck();
        });
        $input.on("blur",function(){
            count(0,maxNumber);
            disableCheck();
        });
        $increase.on(options.clickEvent,function(event){
            count(1,maxNumber);
            disableCheck();
        });
        this.setMax=function(number){
            if(number===false){
                maxNumber=false;
            }else{
                var value=toNumber($input.val());
                maxNumber=toNumber(number);
                maxNumber==0?value=0:(value>maxNumber?value=maxNumber:value==0?value=0:void(0));
                $input.val(value);
                $inputText.text(value);
                typeof(changeFunc)=='function'&&changeFunc.call(_this,value);
                disableCheck();
            }
        };
        this.val=function(value){
            if(typeof(value)=='undefined'){
                return $input.val();
            }else{
                $input.val(value);
                $inputText.text(value);
                return count(0,maxNumber);
            }
        };
        this.getContext = function(){
            return $input;
        };
        disableCheck();
    };
    widget.counter = counter;
}(window,window['widget'] || (window['widget'] = {}));