!function(win,widget){
    var slidePlaySt;
    function slider(element){
        var $sliderScroller=element.parent(),$sliderContainer=$sliderScroller.parents('.focus-list');
        var elements=$sliderScroller.children(),total=elements.length;
        var firstElement=elements.eq(0),lastElement=elements.eq(total-1);
        var displacementX;
        if(total<=1)return false;

        $sliderScroller.css({
            '-webkit-backface-visibility':'hidden'
        });

        var current=0;
        var transitionEndEvent='webkitTransitionEnd transitionend';
        var fullscreenWidth=16*rem,halfScreenWidth=fullscreenWidth/5;
        var playing=false,timeout;

        var nextElement,prevElement,currentElement;

        //clearTimeout(slidePlaySt);


        function checkLazyLoad($element){
            var $img = $element.find('img');
            if($img.attr('lazy-src')){
                $img.attr('src',$img.attr('lazy-src'));
                $img.removeAttr('lazy-src');
            }
        }


        function resetScroller(){
            playing=false;
            clearTimeout(timeout);
            $sliderScroller.css({
                '-webkit-transition':'none',
                '-webkit-transform':'translate3d(0px, 0px, 0px)'
            });
            initElement();
            var $pages=$sliderContainer.find('.pages i');
            $pages.eq(current).addClass('active').siblings().removeClass('active');
            /*clearTimeout(slidePlaySt);
             slidePlaySt=setTimeout(function(){
             nextFunc();
             },4000);*/
        }

        function revertFunc(){
            function revertFuncCallback(){
                prevElement.css({display:'none',zIndex:1});
                nextElement.css({display:'none',zIndex:1});
                currentElement.css({left:0,display:'block',zIndex:10});
                resetScroller();
            }
            playing=true;
            $sliderScroller.css({
                '-webkit-transition':'-webkit-transform 300ms ease-in 0ms',
                '-webkit-transform':'translate3d(0px, 0px, 0px)'
            }).one(transitionEndEvent,revertFuncCallback);
            timeout=setTimeout(revertFuncCallback,500);
        }

        function nextFunc(){
            function nextFuncCallback(){
                currentElement.css({display:'none',zIndex:1});
                nextElement.css({left:0,display:'block',zIndex:10});
                checkLazyLoad(nextElement);
                resetScroller();
            }
            playing=true;
            nextElement.css({left:'16rem','display':'block'});
            current++;
            if(current>(total-1))current=0;
            $sliderScroller.css({
                '-webkit-transition':'-webkit-transform 300ms ease-in 0ms',
                '-webkit-transform':'translate3d(-'+(fullscreenWidth)+'px, 0px, 0px)'
            }).one(transitionEndEvent,nextFuncCallback);
            timeout=setTimeout(nextFuncCallback,500);
        }

        function prevFunc(){
            function prevFuncCallback(){
                currentElement.css({display:'none',zIndex:1});
                prevElement.css({left:0,display:'block',zIndex:10});
                checkLazyLoad(prevElement);
                resetScroller();
            }
            playing=true;
            prevElement.css({left:'-16rem','display':'block'});
            current--;
            if(current<0)current=total-1;
            $sliderScroller.css({
                '-webkit-transition':'-webkit-transform 300ms ease-in 0ms',
                '-webkit-transform':'translate3d('+(fullscreenWidth)+'px, 0px, 0px)'
            }).one(transitionEndEvent,prevFuncCallback);
            timeout=setTimeout(prevFuncCallback,500);
        }

        function initElement(){
            currentElement=elements.eq(current);
            prevElement=current-1<0?lastElement:elements.eq(current-1);
            nextElement=current+1>(total-1)?firstElement:elements.eq(current+1);
        }

        function panstartFunc(event){
            //clearTimeout(slidePlaySt);
        }

        function horizontalpanFunc(event){
            if(!playing){
                event.displacementX>fullscreenWidth?displacementX=fullscreenWidth:event.displacementX<-fullscreenWidth?displacementX=-fullscreenWidth:displacementX=event.displacementX;
                $sliderScroller.css({
                    '-webkit-transform':'translate3d('+displacementX+'px, 0px, 0px)'
                });
                if(displacementX>0){
                    prevElement.css({left:'-16rem','display':'block'});
                }else{
                    nextElement.css({left:'16rem','display':'block'});
                }
                event.touchEvent.preventDefault();
            }
        }

        function panendFunc(event){
            if(Math.abs(displacementX)>(halfScreenWidth)){
                if(displacementX<0){nextFunc();}else{prevFunc();}
            }else{
                revertFunc();
            }
        }

        $sliderContainer.bind('panstart',panstartFunc);
        $sliderContainer.bind('horizontalpan',horizontalpanFunc);
        $sliderContainer.bind('panend',panendFunc);
        elements.css({position:'absolute',left:0,top:0,display:'none'}).eq(0).css({display:'block'});
        resetScroller();

    }
    widget.slider= slider;
}(window, window['widget'] || (window['widget'] = {}));